/*=================================================================*/
/** @file Common.hpp
 *  @brief Common definitons for D2External.DLL.
 *
 *  (c) January 2002 - Joel Falcou for The Phrozen Keep.
 */
/*=================================================================*/

#ifndef __COMMON_HPP__INCLUDED__
#define __COMMON_HPP__INCLUDED__

#include <windows.h>

#include "D2Constants.hpp"

#define APP_VERSION "2.01"
#define STDCALL		__stdcall
#define FASTCALL	__fastcall

typedef void (STDCALL  *D2Common10518)( void* pPlayer, unsigned long pStatID, unsigned long pAmount); 
typedef int  (STDCALL  *D2Common10519)( void* pPlayer, unsigned long pStatID );
typedef int  (FASTCALL *D2Common10918)( void* seed, int rnd );

typedef struct
{
    // Unit Functions

    D2Common10518 D2AddPlayerStat;
    D2Common10519 D2GetPlayerStat;
    D2Common10918 D2GetRandomInt;

} D2FUNCTIONTABLE, *LPD2FUNCTIONTABLE;

#endif