/*=================================================================*/
/** @file Main.cpp
 *  @brief Main file of D2External.DLL
 *
 *  (c) January 2002 - Joel Falcou for The Phrozen Keep.
 */
/*=================================================================*/

#include "D2DLL.hpp"

D2DLL cwDLL;

BOOL WINAPI DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    cwDLL.setModule( hModule );

	switch(dwReason)
    {
		case DLL_PROCESS_ATTACH: 
			cwDLL.init();
			break;

		case DLL_PROCESS_DETACH:
			cwDLL.release();
			break;
	}

	return TRUE;
}