'Foxbat's MOD LAUNCHER Script
'Enhanced by Myhrginoc 4/7/02
'This script will launch a mod in a Diablo II subdirectory in windowed mode.
'  
Dim ErrorFlag
'Create a shell object
Set Shell = WScript.CreateObject("WScript.Shell")
'Get path to Diablo II EXE from registry
D2Path = Shell.RegRead("HKCU\Software\Blizzard Entertainment\Diablo II\InstallPath")& "\"
'Create a file system object
Set FSO = WScript.CreateObject("Scripting.FileSystemObject")
'Get the current directory folder object
Set Folder = FSO.GetFolder(".")
'Ensure script gets to clean up if setting up and launching the mod fails
On Error Resume Next

'Get full pathname of current directory and append save dir name
Dir = Folder.Path & "\Save\"
'Make new save dir if necessary
If (FSO.FolderExists(Dir) = False) then
  Set f = FSO.CreateFolder(Dir)
  If Err.Number > 0 Then
    MsgBox ("Unable to create a new Save directory.  Create manually and try again.")
    WScript.Quit(3)
  End If
End If
'Check for proper installation of Blizzard DLLs in Diablo installation directory
  ErrorFlag = 0
  Set BNClientDLL = FSO.GetFile(D2Path & "Bnclient.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set ClientDLL = FSO.GetFile(D2Path & "D2Client.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set CmpDLL = FSO.GetFile(D2Path & "D2CMP.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set CommonDLL = FSO.GetFile(D2Path & "D2Common.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set Direct3dDLL = FSO.GetFile(D2Path & "D2Direct3D.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set DDRawDLL = FSO.GetFile(D2Path & "D2DDraw.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set GameDLL = FSO.GetFile(D2Path & "D2Game.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set GdiDLL = FSO.GetFile(D2Path & "D2Gdi.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set GfxDLL = FSO.GetFile(D2Path & "D2Gfx.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set GlideDLL = FSO.GetFile(D2Path & "D2Glide.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set LangDLL = FSO.GetFile(D2Path & "D2Lang.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set LaunchDLL = FSO.GetFile(D2Path & "D2Launch.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set MCPClientDLL = FSO.GetFile(D2Path & "D2MCPClient.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set MultiDLL = FSO.GetFile(D2Path & "D2Multi.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set NetDLL = FSO.GetFile(D2Path & "D2Net.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set SoundDLL = FSO.GetFile(D2Path & "D2Sound.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set WinDLL = FSO.GetFile(D2Path & "D2Win.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set FogDLL = FSO.GetFile(D2Path & "Fog.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  Set StormDLL = FSO.GetFile(D2Path & "Storm.dll")
  If Err.Number > 0 Then
    ErrorFlag = ErrorFlag + 1
    Err.Clear
  End If
  If ErrorFlag > 0 Then
    MsgBox ("One or more required DLLs is either not present or has a corrupted name in the Diablo II installation directory.  Run RecoverFromCrash.VBS and try again.")
    WScript.Quit(4)
  End If
'If Diablo path is not the current directory run MOD otherwise just fix up
If Folder.Path & "\" <> D2Path Then
  'Check if D2Client.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Client.dll") Then
    ClientDLL.Move (D2Path & "D2Client.baq")
  End If
  'Check if D2Common.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Common.dll") Then
    CommonDLL.Move (D2Path & "D2Common.baq")
  End If
  'Check if D2Game.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Game.dll") Then
    GameDLL.Move (D2Path & "D2Game.baq")
  End If
  'Check if D2Gfx.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Gfx.dll") Then
    GfxDLL.Move (D2Path & "D2Gfx.baq")
  End If
  'Check if D2Lang.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Lang.dll") Then
    LangDLL.Move (D2Path & "D2Lang.baq")
  End If
  'Check if D2Sound.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Sound.dll") Then
    SoundDLL.Move (D2Path & "D2Sound.baq")
  End If
  'Check if D2Win.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Win.dll") Then
    WinDLL.Move (D2Path & "D2Win.baq")
  End If
  'Check if Fog.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\Fog.dll") Then
    FogDLL.Move (D2Path & "Fog.baq")
  End If
  'Check if Storm.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\Storm.dll") Then
    StormDLL.Move (D2Path & "Storm.baq")
  End If
  'Get current save folder
  SaveDir = Shell.RegRead("HKCU\Software\Blizzard Entertainment\Diablo II\Save Path")
  'Write our new save directory in the registry
  Shell.RegWrite "HKCU\Software\Blizzard Entertainment\Diablo II\Save Path", Dir, "REG_SZ"

  'Launch Diablo II normally and wait for it to finish
  Result = Shell.Run(chr(34) & D2Path & "Game.exe" & chr(34) & " /dll " & chr(34) & D2Path & "D2Cabal.dll" & chr(34) & "-w -direct -txt" & chr(34), 1, TRUE)
  'Restore name to Blizzard's D2Client.dll
  If ClientDLL.Name = "D2Client.baq" Then
    ClientDLL.Move (D2Path & "D2Client.dll")
  End If
  'Restore name to Blizzard's D2Common.dll
  If CommonDLL.Name = "D2Common.baq" Then
    CommonDLL.Move (D2Path & "D2Common.dll")
  End If
  'Restore name to Blizzard's D2Game.dll
  If GameDLL.Name = "D2Game.baq" Then
    GameDLL.Move (D2Path & "D2Game.dll")
  End If
  'Restore name to Blizzard's D2Gfx.dll
  If GfxDLL.Name = "D2Gfx.baq" Then
    GfxDLL.Move (D2Path & "D2Gfx.dll")
  End If
  'Restore name to Blizzard's D2Lang.dll
  If LangDLL.Name = "D2Lang.baq" Then
    LangDLL.Move (D2Path & "D2Lang.dll")
  End If
  'Restore name to Blizzard's D2Sound.dll
  If SoundDLL.Name = "D2Sound.baq" Then
    SoundDLL.Move (D2Path & "D2Sound.dll")
  End If
  'Restore name to Blizzard's D2Win.dll
  If WinDLL.Name = "D2Win.baq" Then
    WinDLL.Move (D2Path & "D2Win.dll")
  End If
  'Restore name to Blizzard's Fog.dll
  If FogDLL.Name = "Fog.baq" Then
    FogDLL.Move (D2Path & "Fog.dll")
  End If
  'Restore name to Blizzard's Storm.dll
  If StormDLL.Name = "Storm.baq" Then
    StormDLL.Move (D2Path & "Storm.dll")
  End If
End If
On Error GoTo 0
'Restore previous save directory setting in registry
Shell.RegWrite "HKCU\Software\Blizzard Entertainment\Diablo II\Save Path", SaveDir, "REG_SZ"
WScript.Quit(0)